# Visualization Library

A lightweight C++ OpenGL middleware for 2D/3D graphics

[Home] [Tutorials] [All Classes] [Grouped Classes]

# vlGLUT::GLUTWindow Class Reference

The GLUTWindow class implements an OpenGLContext using the GLUT API. More...

`#include <GLUTWindow.hpp>`

Inheritance diagram for vlGLUT::GLUTWindow:

List of all members.

## Public Member Functions

| GLUTWindow ()
| GLUTWindow (const vl::String &title, const vl::OpenGLContextFormat &info, int x, int y, int width, int height)
bool | initGLUTWindow (const vl::String &title, const vl::OpenGLContextFormat &info, int x, int y, int width, int height)
| Initializes and shows a GLUT window.
| ~GLUTWindow ()
virtual void | setMouseVisible (bool visible)
virtual void | setMousePosition (int x, int y)
void | quitApplication ()
| Quits the progra calling the C function exit(0).
void | update ()
bool | setFullscreen (bool fs)
void | makeCurrent ()
void | destroy ()
void | updateOverlay ()
void | swapBuffers ()
void | setWindowTitle (const vl::String &title)
int | handle () const
void | setPosition (int x, int y)
void | setSize (int w, int h)
vl::ivec2 | position () const
vl::ivec2 | size () const
void | show ()
void | hide ()
void | getFocus ()

## Protected Member Functions

void | initKeymap ()
vl::EKey | mapAsciiKey (unsigned char ascii)
void | updateModifiers ()

## Static Protected Member Functions

static vl::EKey | mapSpecialKey (int special_key)
static void | glut_keyboard_func (unsigned char ch, int x, int y)
static void | glut_keyboard_up_func (unsigned char ch, int x, int y)
static void | glut_special_func (int key, int x, int y)
static void | glut_special_up_func (int key, int x, int y)
static void | glut_mouse_func (int button, int state, int x, int y)
static void | glut_motion_func (int x, int y)
static void | glut_passive_motion_func (int x, int y)
static void | glut_mouse_wheel_func (int a, int rotation, int c, int d)
static void | glut_visibility_func (int visibility)
static void | glut_reshape_func (int w, int h)
static void | glut_display_func ()
static void | glut_wmclose_func ()
static void | glut_close_func ()
static void | glut_idle_func ()

## Protected Attributes

std::map< unsigned char, vl::EKey > | mKeymap
int | mHandle
bool | mInited

## Static Protected Attributes

static std::map< int, GLUTWindow * > | mWinMap

## Detailed Description

The GLUTWindow class implements an OpenGLContext using the GLUT API.

## Constructor & Destructor Documentation

GLUTWindow::GLUTWindow | ( |  | ) |

GLUTWindow::GLUTWindow | ( | const vl::String & | title,
|  | const vl::OpenGLContextFormat & | info,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

vlGLUT::GLUTWindow::~GLUTWindow | ( |  | ) | `[inline]`

## Member Function Documentation

bool GLUTWindow::initGLUTWindow | ( | const vl::String & | title,
|  | const vl::OpenGLContextFormat & | info,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

Initializes and shows a GLUT window.

*

*

*

*

*

*

*

*

*

*

*

*

*

*

void GLUTWindow::setMouseVisible | ( | bool | visible | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::setMousePosition | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Reimplemented from vl::OpenGLContext.

void vlGLUT::GLUTWindow::quitApplication | ( |  | ) | `[inline, virtual]`

Quits the progra calling the C function exit(0).

Reimplemented from vl::OpenGLContext.

void GLUTWindow::update | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

bool GLUTWindow::setFullscreen | ( | bool | fs | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::makeCurrent | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::destroy | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::updateOverlay | ( |  | ) |

void GLUTWindow::swapBuffers | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::setWindowTitle | ( | const vl::String & | title | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

int vlGLUT::GLUTWindow::handle | ( |  | ) | const`[inline]`

void GLUTWindow::setPosition | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::setSize | ( | int | w,
|  | int | h |
| ) |  |  | `[virtual]`

Reimplemented from vl::OpenGLContext.

vl::ivec2 GLUTWindow::position | ( |  | ) | const`[virtual]`

Reimplemented from vl::OpenGLContext.

vl::ivec2 GLUTWindow::size | ( |  | ) | const`[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::show | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::hide | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::getFocus | ( |  | ) | `[virtual]`

Reimplemented from vl::OpenGLContext.

void GLUTWindow::initKeymap | ( |  | ) | `[protected]`

vl::EKey GLUTWindow::mapAsciiKey | ( | unsigned char | ascii | ) | `[protected]`

vl::EKey GLUTWindow::mapSpecialKey | ( | int | special_key | ) | `[static, protected]`

void GLUTWindow::updateModifiers | ( |  | ) | `[protected]`

void GLUTWindow::glut_keyboard_func | ( | unsigned char | ch,
|  | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_keyboard_up_func | ( | unsigned char | ch,
|  | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_special_func | ( | int | key,
|  | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_special_up_func | ( | int | key,
|  | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_mouse_func | ( | int | button,
|  | int | state,
|  | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_motion_func | ( | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_passive_motion_func | ( | int | x,
|  | int | y |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_mouse_wheel_func | ( | int | a,
|  | int | rotation,
|  | int | c,
|  | int | d |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_visibility_func | ( | int | visibility | ) | `[static, protected]`

void GLUTWindow::glut_reshape_func | ( | int | w,
|  | int | h |
| ) |  |  | `[static, protected]`

void GLUTWindow::glut_display_func | ( |  | ) | `[static, protected]`

void GLUTWindow::glut_wmclose_func | ( |  | ) | `[static, protected]`

void GLUTWindow::glut_close_func | ( |  | ) | `[static, protected]`

void GLUTWindow::glut_idle_func | ( |  | ) | `[static, protected]`

## Member Data Documentation

std::map<unsigned char, vl::EKey> vlGLUT::GLUTWindow::mKeymap`[protected]`

int vlGLUT::GLUTWindow::mHandle`[protected]`

bool vlGLUT::GLUTWindow::mInited`[protected]`

std::map< int, GLUTWindow * > GLUTWindow::mWinMap`[static, protected]`

The documentation for this class was generated from the following files:

- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGLUT/GLUTWindow.hpp
- E:/VisualizationLibrary/BuildSystem/VL_DISTRO/Visualization_Library_SDK/src/vlGLUT/GLUTWindow.cpp

Visualization Library v2009.07 Reference Documentation
Copyright 2005-2009 Michele Bosi. All rights reserved.
Updated on Mon Aug 10 21:41:48 2009.
Permission is granted to use this page to write and publish articles regarding Visualization Library.